Index: dev/ic/pckbc.c
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/pckbc.c,v
retrieving revision 1.51
diff -u -b -r1.51 pckbc.c
--- dev/ic/pckbc.c	8 Aug 2010 09:33:05 -0000	1.51
+++ dev/ic/pckbc.c	31 Oct 2011 04:29:14 -0000
@@ -59,7 +59,7 @@
 	int poll_data;	/* data read from inr handler if polling */
 	int poll_stat;	/* status read from inr handler if polling */
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/ic/rtl81x9var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/rtl81x9var.h,v
retrieving revision 1.50
diff -u -b -r1.50 rtl81x9var.h
--- dev/ic/rtl81x9var.h	27 Jul 2010 21:02:00 -0000	1.50
+++ dev/ic/rtl81x9var.h	31 Oct 2011 04:29:14 -0000
@@ -226,7 +226,7 @@
 	int	(*sc_enable)	(struct rtk_softc *);
 	void	(*sc_disable)	(struct rtk_softc *);
 #if NRND > 0
-	rndsource_element_t     rnd_source;
+	krndsource_t     rnd_source;
 #endif
 };
 
Index: dev/ic/seeq8005var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/seeq8005var.h,v
retrieving revision 1.5
diff -u -b -r1.5 seeq8005var.h
--- dev/ic/seeq8005var.h	7 Nov 2001 20:01:58 -0000	1.5
+++ dev/ic/seeq8005var.h	31 Oct 2011 04:29:14 -0000
@@ -86,7 +86,7 @@
 	int sc_flags;
 #define SF_8BIT		0x01
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/ic/smc91cxxvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/smc91cxxvar.h,v
retrieving revision 1.16
diff -u -b -r1.16 smc91cxxvar.h
--- dev/ic/smc91cxxvar.h	12 May 2009 14:25:18 -0000	1.16
+++ dev/ic/smc91cxxvar.h	31 Oct 2011 04:29:14 -0000
@@ -61,7 +61,7 @@
 	uint8_t		sc_intmask;
 	uint8_t		sc_txpacketno;		/* cached packetno */
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/ic/tulipvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/ic/tulipvar.h,v
retrieving revision 1.65
diff -u -b -r1.65 tulipvar.h
--- dev/ic/tulipvar.h	9 Jul 2011 23:18:05 -0000	1.65
+++ dev/ic/tulipvar.h	31 Oct 2011 04:29:15 -0000
@@ -448,7 +448,7 @@
 	int	sc_rxptr;		/* next ready RX descriptor/descsoft */
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source; /* random source */
+	krndsource_t sc_rnd_source; /* random source */
 #endif
 };
 #endif
Index: dev/isa/fdvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/isa/fdvar.h,v
retrieving revision 1.6
diff -u -b -r1.6 fdvar.h
--- dev/isa/fdvar.h	28 Apr 2008 20:23:52 -0000	1.6
+++ dev/isa/fdvar.h	31 Oct 2011 04:29:15 -0000
@@ -91,6 +91,6 @@
 	int sc_active;		/* number of active I/O operations */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
Index: dev/isa/if_eg.c
===================================================================
RCS file: /cvsroot/src/sys/dev/isa/if_eg.c,v
retrieving revision 1.82
diff -u -b -r1.82 if_eg.c
--- dev/isa/if_eg.c	5 Apr 2010 07:20:24 -0000	1.82
+++ dev/isa/if_eg.c	31 Oct 2011 04:29:15 -0000
@@ -114,7 +114,7 @@
 	void *	eg_outbuf;		/* Outgoing packet buffer */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/isa/if_el.c
===================================================================
RCS file: /cvsroot/src/sys/dev/isa/if_el.c,v
retrieving revision 1.86
diff -u -b -r1.86 if_el.c
--- dev/isa/if_el.c	5 Apr 2010 07:20:24 -0000	1.86
+++ dev/isa/if_el.c	31 Oct 2011 04:29:15 -0000
@@ -80,7 +80,7 @@
 	bus_space_handle_t sc_ioh;	/* i/o handle */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/isa/if_iy.c
===================================================================
RCS file: /cvsroot/src/sys/dev/isa/if_iy.c,v
retrieving revision 1.88
diff -u -b -r1.88 if_iy.c
--- dev/isa/if_iy.c	5 Apr 2010 07:20:24 -0000	1.88
+++ dev/isa/if_iy.c	31 Oct 2011 04:29:15 -0000
@@ -129,7 +129,7 @@
 #endif
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/marvell/if_gfevar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/marvell/if_gfevar.h,v
retrieving revision 1.10
diff -u -b -r1.10 if_gfevar.h
--- dev/marvell/if_gfevar.h	28 Apr 2010 13:51:56 -0000	1.10
+++ dev/marvell/if_gfevar.h	31 Oct 2011 04:29:15 -0000
@@ -168,7 +168,7 @@
 	struct gfe_rxqueue sc_rxq[4];	/* Hi/MedHi/MedLo/Lo receive queues */
 
 #if NRND > 0 
-	rndsource_element_t sc_rnd_source;
+	krndsource_t sc_rnd_source;
 #endif
 };
 #endif	/* _IF_GFEVAR_H_ */
Index: dev/marvell/if_mvgbe.c
===================================================================
RCS file: /cvsroot/src/sys/dev/marvell/if_mvgbe.c,v
retrieving revision 1.13
diff -u -b -r1.13 if_mvgbe.c
--- dev/marvell/if_mvgbe.c	6 Sep 2011 19:38:23 -0000	1.13
+++ dev/marvell/if_mvgbe.c	31 Oct 2011 04:29:15 -0000
@@ -216,7 +216,7 @@
 	SIMPLEQ_HEAD(__mvgbe_txmaphead, mvgbe_txmap_entry) sc_txmap_head;
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source;
+	krndsource_t sc_rnd_source;
 #endif
 };
 
Index: dev/mca/edvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/mca/edvar.h,v
retrieving revision 1.13
diff -u -b -r1.13 edvar.h
--- dev/mca/edvar.h	4 May 2008 13:11:14 -0000	1.13
+++ dev/mca/edvar.h	31 Oct 2011 04:29:15 -0000
@@ -61,6 +61,6 @@
 	u_int32_t rba;		/* # of RBAs */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
Index: dev/pci/amdpmvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/amdpmvar.h,v
retrieving revision 1.6
diff -u -b -r1.6 amdpmvar.h
--- dev/pci/amdpmvar.h	28 Apr 2008 20:23:54 -0000	1.6
+++ dev/pci/amdpmvar.h	31 Oct 2011 04:29:16 -0000
@@ -52,7 +52,7 @@
 	void *sc_ih;
 
 	struct callout sc_rnd_ch;
-	rndsource_element_t sc_rnd_source;
+	krndsource_t sc_rnd_source;
 #ifdef AMDPM_RND_COUNTERS
 	struct evcnt sc_rnd_hits;
 	struct evcnt sc_rnd_miss;
Index: dev/pci/hifn7751.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/hifn7751.c,v
retrieving revision 1.46
diff -u -b -r1.46 hifn7751.c
--- dev/pci/hifn7751.c	13 Nov 2010 13:52:05 -0000	1.46
+++ dev/pci/hifn7751.c	31 Oct 2011 04:29:16 -0000
@@ -50,13 +50,6 @@
 #include <sys/cdefs.h>
 __KERNEL_RCSID(0, "$NetBSD: hifn7751.c,v 1.46 2010/11/13 13:52:05 uebayasi Exp $");
 
-#include "rnd.h"
-
-#if NRND == 0
-#error hifn7751 requires rnd pseudo-devices
-#endif
-
-
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/proc.h>
@@ -71,7 +64,7 @@
 #include <dev/rndvar.h>
 #else
 #include <opencrypto/cryptodev.h>
-#include <sys/rnd.h>
+#include <sys/cprng.h>
 #endif
 
 #include <dev/pci/pcireg.h>
@@ -2077,7 +2070,7 @@
 			   to generate IVs has been FIPS140-2
 			   certified by several labs. */
 #ifdef __NetBSD__
-			arc4randbytes(sc->sc_sessions[i].hs_iv,
+			cprng_fast(sc->sc_sessions[i].hs_iv,
 			    c->cri_alg == CRYPTO_AES_CBC ?
 				HIFN_AES_IV_LENGTH : HIFN_IV_LENGTH);
 #else	/* FreeBSD and OpenBSD have get_random_bytes */
Index: dev/pci/hifn7751var.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/hifn7751var.h,v
retrieving revision 1.7
diff -u -b -r1.7 hifn7751var.h
--- dev/pci/hifn7751var.h	11 Dec 2005 12:22:49 -0000	1.7
+++ dev/pci/hifn7751var.h	31 Oct 2011 04:29:16 -0000
@@ -168,7 +168,7 @@
 
 	struct callout		sc_rngto;	/* rng timeout */
 	struct callout		sc_tickto;	/* led-clear timeout */
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 	int			sc_rngfirst;
 	int			sc_rnghz;
 	int			sc_c_busy;	/* command ring busy */
Index: dev/pci/if_bce.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_bce.c,v
retrieving revision 1.33
diff -u -b -r1.33 if_bce.c
--- dev/pci/if_bce.c	13 Nov 2010 13:52:05 -0000	1.33
+++ dev/pci/if_bce.c	31 Oct 2011 04:29:16 -0000
@@ -139,7 +139,7 @@
 	int			bce_txsnext;	/* next available tx slot */
 	callout_t		bce_timeout;
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/pci/if_bgevar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_bgevar.h,v
retrieving revision 1.7
diff -u -b -r1.7 if_bgevar.h
--- dev/pci/if_bgevar.h	18 May 2011 01:02:43 -0000	1.7
+++ dev/pci/if_bgevar.h	31 Oct 2011 04:29:16 -0000
@@ -290,7 +290,7 @@
 	struct sysctllog	*bge_log;
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;	/* random source */
+	krndsource_t	rnd_source;	/* random source */
 #endif
 };
 
Index: dev/pci/if_casvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_casvar.h,v
retrieving revision 1.2
diff -u -b -r1.2 if_casvar.h
--- dev/pci/if_casvar.h	18 Jan 2010 18:09:22 -0000	1.2
+++ dev/pci/if_casvar.h	31 Oct 2011 04:29:16 -0000
@@ -195,7 +195,7 @@
 	void			*sc_sh;		/* shutdownhook cookie */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 
 	struct evcnt		sc_ev_intr;
Index: dev/pci/if_devar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_devar.h,v
retrieving revision 1.55
diff -u -b -r1.55 if_devar.h
--- dev/pci/if_devar.h	5 Apr 2010 07:20:25 -0000	1.55
+++ dev/pci/if_devar.h	31 Oct 2011 04:29:17 -0000
@@ -695,7 +695,7 @@
     tulip_desc_t *tulip_rxdescs;
     tulip_desc_t *tulip_txdescs;
 #if defined(__NetBSD__) && NRND > 0
-    rndsource_element_t    tulip_rndsource;
+    krndsource_t    tulip_rndsource;
 #endif
 };
 
Index: dev/pci/if_dge.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_dge.c,v
retrieving revision 1.31
diff -u -b -r1.31 if_dge.c
--- dev/pci/if_dge.c	13 Nov 2010 13:52:06 -0000	1.31
+++ dev/pci/if_dge.c	31 Oct 2011 04:29:17 -0000
@@ -334,7 +334,7 @@
 	uint16_t sc_eeprom[EEPROM_SIZE];
 
 #if NRND > 0
-	rndsource_element_t rnd_source; /* random source */
+	krndsource_t rnd_source; /* random source */
 #endif
 #ifdef DGE_OFFBYONE_RXBUG
 	void *sc_bugbuf;
Index: dev/pci/if_iwi.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_iwi.c,v
retrieving revision 1.87
diff -u -b -r1.87 if_iwi.c
--- dev/pci/if_iwi.c	23 May 2011 15:37:36 -0000	1.87
+++ dev/pci/if_iwi.c	31 Oct 2011 04:29:17 -0000
@@ -38,6 +38,7 @@
 #include <sys/conf.h>
 #include <sys/kauth.h>
 #include <sys/proc.h>
+#include <sys/cprng.h>
 
 #include <sys/bus.h>
 #include <machine/endian.h>
@@ -2386,7 +2387,8 @@
 			return error;
 	}
 
-	data = htole32(arc4random());
+	cprng_fast(&data, sizeof(data));
+	data = htole32(data);
 	DPRINTF(("Setting initialization vector to %u\n", le32toh(data)));
 	error = iwi_cmd(sc, IWI_CMD_SET_IV, &data, sizeof data, 0);
 	if (error != 0)
Index: dev/pci/if_jme.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_jme.c,v
retrieving revision 1.17
diff -u -b -r1.17 if_jme.c
--- dev/pci/if_jme.c	30 Mar 2011 18:11:37 -0000	1.17
+++ dev/pci/if_jme.c	31 Oct 2011 04:29:17 -0000
@@ -168,7 +168,7 @@
 	uint32_t jme_txcsr;		/* TX config register */
 	uint32_t jme_rxcsr;		/* RX config register */
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 	/* interrupt coalition parameters */
 	struct sysctllog *jme_clog;
Index: dev/pci/if_mskvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_mskvar.h,v
retrieving revision 1.8
diff -u -b -r1.8 if_mskvar.h
--- dev/pci/if_mskvar.h	24 Dec 2009 18:27:32 -0000	1.8
+++ dev/pci/if_mskvar.h	31 Oct 2011 04:29:17 -0000
@@ -210,7 +210,7 @@
 	int			sk_status_idx;
 	int			sk_status_own_idx;
 #if NRND > 0
-	rndsource_element_t     rnd_source;
+	krndsource_t     rnd_source;
 #endif
 };
 
Index: dev/pci/if_pcn.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_pcn.c,v
retrieving revision 1.52
diff -u -b -r1.52 if_pcn.c
--- dev/pci/if_pcn.c	13 Nov 2010 13:52:06 -0000	1.52
+++ dev/pci/if_pcn.c	31 Oct 2011 04:29:18 -0000
@@ -313,7 +313,7 @@
 	uint32_t sc_mode;		/* prototype MODE register */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;	/* random source */
+	krndsource_t rnd_source;	/* random source */
 #endif
 };
 
Index: dev/pci/if_sip.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_sip.c,v
retrieving revision 1.150
diff -u -b -r1.150 if_sip.c
--- dev/pci/if_sip.c	15 Oct 2011 19:50:20 -0000	1.150
+++ dev/pci/if_sip.c	31 Oct 2011 04:29:19 -0000
@@ -355,7 +355,7 @@
 	void (*sc_rxintr)(struct sip_softc *);
 
 #if NRND > 0
-	rndsource_element_t rnd_source;	/* random source */
+	krndsource_t rnd_source;	/* random source */
 #endif
 };
 
Index: dev/pci/if_skvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_skvar.h,v
retrieving revision 1.15
diff -u -b -r1.15 if_skvar.h
--- dev/pci/if_skvar.h	8 Sep 2008 21:20:03 -0000	1.15
+++ dev/pci/if_skvar.h	31 Oct 2011 04:29:19 -0000
@@ -205,7 +205,7 @@
 	bus_dma_tag_t		sc_dmatag;
 	struct sk_if_softc	*sk_if[2];
 #if NRND > 0
-	rndsource_element_t     rnd_source;
+	krndsource_t     rnd_source;
 #endif
 };
 
Index: dev/pci/if_tlvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_tlvar.h,v
retrieving revision 1.14
diff -u -b -r1.14 if_tlvar.h
--- dev/pci/if_tlvar.h	19 Oct 2009 18:41:15 -0000	1.14
+++ dev/pci/if_tlvar.h	31 Oct 2011 04:29:19 -0000
@@ -85,7 +85,7 @@
 	int oerr_mcopy;
 #endif
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 #define tl_if            tl_ec.ec_if
Index: dev/pci/if_vr.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_vr.c,v
retrieving revision 1.107
diff -u -b -r1.107 if_vr.c
--- dev/pci/if_vr.c	16 Dec 2010 17:07:44 -0000	1.107
+++ dev/pci/if_vr.c	31 Oct 2011 04:29:19 -0000
@@ -234,7 +234,7 @@
 	uint32_t	vr_save_irq;
 
 #if NRND > 0
-	rndsource_element_t rnd_source;	/* random source */
+	krndsource_t rnd_source;	/* random source */
 #endif
 };
 
Index: dev/pci/if_vtevar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_vtevar.h,v
retrieving revision 1.1
diff -u -b -r1.1 if_vtevar.h
--- dev/pci/if_vtevar.h	26 Jan 2011 18:48:13 -0000	1.1
+++ dev/pci/if_vtevar.h	31 Oct 2011 04:29:19 -0000
@@ -139,7 +139,7 @@
 	int			vte_int_tx_mod;
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/pci/if_wm.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/if_wm.c,v
retrieving revision 1.223
diff -u -b -r1.223 if_wm.c
--- dev/pci/if_wm.c	1 Jul 2011 07:45:39 -0000	1.223
+++ dev/pci/if_wm.c	31 Oct 2011 04:29:20 -0000
@@ -379,7 +379,7 @@
 	int sc_mchash_type;		/* multicast filter offset */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;	/* random source */
+	krndsource_t rnd_source;	/* random source */
 #endif
 };
 
Index: dev/pci/ubsec.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/ubsec.c,v
retrieving revision 1.25
diff -u -b -r1.25 ubsec.c
--- dev/pci/ubsec.c	13 Nov 2010 13:52:09 -0000	1.25
+++ dev/pci/ubsec.c	31 Oct 2011 04:29:20 -0000
@@ -65,7 +65,7 @@
  #include <dev/rndvar.h>
  #include <sys/md5k.h>
 #else
- #include <sys/rnd.h>
+ #include <sys/cprng.h>
  #include <sys/md5.h>
 #endif
 #include <sys/sha1.h>
@@ -808,8 +808,7 @@
 	if (encini) {
 		/* get an IV, network byte order */
 #ifdef __NetBSD__
-		rnd_extract_data(ses->ses_iv,
-		    sizeof(ses->ses_iv), RND_EXTRACT_ANY);
+		cprng_fast(ses->ses_iv, sizeof(ses->ses_iv));
 #else
 		get_random_bytes(ses->ses_iv, sizeof(ses->ses_iv));
 #endif
Index: dev/pci/ixgbe/ixgbe.c
===================================================================
RCS file: /cvsroot/src/sys/dev/pci/ixgbe/ixgbe.c,v
retrieving revision 1.1
diff -u -b -r1.1 ixgbe.c
--- dev/pci/ixgbe/ixgbe.c	12 Aug 2011 21:55:29 -0000	1.1
+++ dev/pci/ixgbe/ixgbe.c	31 Oct 2011 04:29:21 -0000
@@ -4160,7 +4160,7 @@
 		reta = 0;
 
 		/* set up random bits */
-		arc4randbytes(&r, sizeof(r));
+		cprng_fast(&r, sizeof(r));
 
 		/* Set up the redirection table */
 		for (i = 0, j = 0; i < 128; i++, j++) {
Index: dev/pcmcia/if_xivar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/pcmcia/if_xivar.h,v
retrieving revision 1.6
diff -u -b -r1.6 if_xivar.h
--- dev/pcmcia/if_xivar.h	6 Dec 2009 23:05:39 -0000	1.6
+++ dev/pcmcia/if_xivar.h	31 Oct 2011 04:29:21 -0000
@@ -45,7 +45,7 @@
 	u_int8_t	sc_rev;			/* Chip revision */
 
 #if NRND > 0
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 #endif
 };
 
Index: dev/scsipi/cdvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/scsipi/cdvar.h,v
retrieving revision 1.29
diff -u -b -r1.29 cdvar.h
--- dev/scsipi/cdvar.h	19 Oct 2009 18:41:16 -0000	1.29
+++ dev/scsipi/cdvar.h	31 Oct 2011 04:29:21 -0000
@@ -48,6 +48,6 @@
 	struct callout sc_callout;
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
Index: dev/scsipi/sdvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/scsipi/sdvar.h,v
retrieving revision 1.32
diff -u -b -r1.32 sdvar.h
--- dev/scsipi/sdvar.h	10 Apr 2009 17:36:42 -0000	1.32
+++ dev/scsipi/sdvar.h	31 Oct 2011 04:29:21 -0000
@@ -92,7 +92,7 @@
 	char name[16]; /* product name, for default disklabel */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: dev/scsipi/stvar.h
===================================================================
RCS file: /cvsroot/src/sys/dev/scsipi/stvar.h,v
retrieving revision 1.21
diff -u -b -r1.21 stvar.h
--- dev/scsipi/stvar.h	6 Dec 2009 22:48:17 -0000	1.21
+++ dev/scsipi/stvar.h	31 Oct 2011 04:29:21 -0000
@@ -147,7 +147,7 @@
 	struct io_stats *stats;		/* statistics for the drive */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: dev/usb/if_auereg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_auereg.h,v
retrieving revision 1.23
diff -u -b -r1.23 if_auereg.h
--- dev/usb/if_auereg.h	4 Sep 2009 18:10:08 -0000	1.23
+++ dev/usb/if_auereg.h	31 Oct 2011 04:29:21 -0000
@@ -229,7 +229,7 @@
 	struct ethercom		aue_ec;
 	struct mii_data		aue_mii;
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 	struct lwp		*aue_thread;
 	int			aue_closing;
Index: dev/usb/if_axereg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_axereg.h,v
retrieving revision 1.12
diff -u -b -r1.12 if_axereg.h
--- dev/usb/if_axereg.h	14 Aug 2010 10:47:57 -0000	1.12
+++ dev/usb/if_axereg.h	31 Oct 2011 04:29:21 -0000
@@ -200,7 +200,7 @@
 	struct ethercom		axe_ec;
 	struct mii_data		axe_mii;
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 	usbd_device_handle	axe_udev;
 	usbd_interface_handle	axe_iface;
Index: dev/usb/if_cdcereg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_cdcereg.h,v
retrieving revision 1.5
diff -u -b -r1.5 if_cdcereg.h
--- dev/usb/if_cdcereg.h	4 Sep 2009 18:10:08 -0000	1.5
+++ dev/usb/if_cdcereg.h	31 Oct 2011 04:29:21 -0000
@@ -69,7 +69,7 @@
 	device_t cdce_dev;
 	struct ethercom		 cdce_ec;
 #if NRND > 0
-	rndsource_element_t	 rnd_source;
+	krndsource_t	 rnd_source;
 #endif
 #define GET_IFP(sc) (&(sc)->cdce_ec.ec_if)
 	usbd_device_handle	 cdce_udev;
Index: dev/usb/if_cuereg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_cuereg.h,v
retrieving revision 1.16
diff -u -b -r1.16 if_cuereg.h
--- dev/usb/if_cuereg.h	4 Sep 2009 18:10:08 -0000	1.16
+++ dev/usb/if_cuereg.h	31 Oct 2011 04:29:21 -0000
@@ -169,7 +169,7 @@
 
 	struct ethercom		cue_ec;
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 #define GET_IFP(sc) (&(sc)->cue_ec.ec_if)
 
Index: dev/usb/if_kuereg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_kuereg.h,v
retrieving revision 1.16
diff -u -b -r1.16 if_kuereg.h
--- dev/usb/if_kuereg.h	3 Nov 2010 22:30:50 -0000	1.16
+++ dev/usb/if_kuereg.h	31 Oct 2011 04:29:21 -0000
@@ -163,7 +163,7 @@
 
 	struct ethercom		kue_ec;
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 #define GET_IFP(sc) (&(sc)->kue_ec.ec_if)
 
Index: dev/usb/if_udavreg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_udavreg.h,v
retrieving revision 1.6
diff -u -b -r1.6 if_udavreg.h
--- dev/usb/if_udavreg.h	3 Nov 2010 22:30:50 -0000	1.6
+++ dev/usb/if_udavreg.h	31 Oct 2011 04:29:21 -0000
@@ -190,7 +190,7 @@
 	int			sc_link;
 #define	sc_media udav_mii.mii_media
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 	struct udav_cdata	sc_cdata;
 
Index: dev/usb/if_upl.c
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_upl.c,v
retrieving revision 1.38
diff -u -b -r1.38 if_upl.c
--- dev/usb/if_upl.c	3 Nov 2010 22:28:31 -0000	1.38
+++ dev/usb/if_upl.c	31 Oct 2011 04:29:21 -0000
@@ -135,7 +135,7 @@
 
 	struct ifnet		sc_if;
 #if NRND > 0
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 #endif
 
 	struct callout		sc_stat_ch;
Index: dev/usb/if_urlreg.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/if_urlreg.h,v
retrieving revision 1.6
diff -u -b -r1.6 if_urlreg.h
--- dev/usb/if_urlreg.h	3 Nov 2010 22:30:50 -0000	1.6
+++ dev/usb/if_urlreg.h	31 Oct 2011 04:29:21 -0000
@@ -176,7 +176,7 @@
 	int			sc_link;
 #define	sc_media url_mii.mii_media
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 	struct url_cdata	sc_cdata;
 
Index: dev/usb/ucom.c
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/ucom.c,v
retrieving revision 1.87
diff -u -b -r1.87 ucom.c
--- dev/usb/ucom.c	24 Apr 2011 16:27:01 -0000	1.87
+++ dev/usb/ucom.c	31 Oct 2011 04:29:22 -0000
@@ -147,7 +147,7 @@
 	u_char			sc_dying;	/* disconnecting */
 
 #if defined(__NetBSD__) && NRND > 0
-	rndsource_element_t	sc_rndsource;	/* random source */
+	krndsource_t	sc_rndsource;	/* random source */
 #endif
 };
 
Index: dev/usb/uhidev.h
===================================================================
RCS file: /cvsroot/src/sys/dev/usb/uhidev.h,v
retrieving revision 1.10
diff -u -b -r1.10 uhidev.h
--- dev/usb/uhidev.h	3 Nov 2010 22:34:24 -0000	1.10
+++ dev/usb/uhidev.h	31 Oct 2011 04:29:22 -0000
@@ -68,7 +68,7 @@
 #define	UHIDEV_OPEN	0x01	/* device is open */
 	void (*sc_intr)(struct uhidev *, void *, u_int);
 #if NRND > 0
-        rndsource_element_t     rnd_source;
+        krndsource_t     rnd_source;
 #endif
 };
 
Index: fs/tmpfs/tmpfs_subr.c
===================================================================
RCS file: /cvsroot/src/sys/fs/tmpfs/tmpfs_subr.c,v
retrieving revision 1.77
diff -u -b -r1.77 tmpfs_subr.c
--- fs/tmpfs/tmpfs_subr.c	27 Aug 2011 15:32:28 -0000	1.77
+++ fs/tmpfs/tmpfs_subr.c	31 Oct 2011 04:29:23 -0000
@@ -124,7 +124,7 @@
 	 * for applications that do not understand 64-bit ino_t.
 	 */
 	nnode->tn_id = (ino_t)((uintptr_t)nnode / sizeof(*nnode));
-	nnode->tn_gen = TMPFS_NODE_GEN_MASK & arc4random();
+	nnode->tn_gen = TMPFS_NODE_GEN_MASK & random();
 
 	/* Generic initialization. */
 	nnode->tn_type = type;
Index: kern/exec_elf.c
===================================================================
RCS file: /cvsroot/src/sys/kern/exec_elf.c,v
retrieving revision 1.32
diff -u -b -r1.32 exec_elf.c
--- kern/exec_elf.c	27 Aug 2011 17:53:21 -0000	1.32
+++ kern/exec_elf.c	31 Oct 2011 04:29:23 -0000
@@ -77,6 +77,7 @@
 #include <sys/stat.h>
 #include <sys/kauth.h>
 #include <sys/bitops.h>
+#include <sys/cprng.h>
 
 #include <sys/cpu.h>
 #include <machine/reg.h>
@@ -134,7 +135,7 @@
 
 		pax_align = align;
 
-		r = arc4random();
+		r = cprng_fast32();
 
 		if (pax_align == 0)
 			pax_align = PGSHIFT;
Index: kern/init_main.c
===================================================================
RCS file: /cvsroot/src/sys/kern/init_main.c,v
retrieving revision 1.436
diff -u -b -r1.436 init_main.c
--- kern/init_main.c	28 Sep 2011 15:52:47 -0000	1.436
+++ kern/init_main.c	31 Oct 2011 04:29:23 -0000
@@ -186,9 +186,7 @@
 #endif
 #include <sys/domain.h>
 #include <sys/namei.h>
-#if NRND > 0
 #include <sys/rnd.h>
-#endif
 #include <sys/pipe.h>
 #if NVERIEXEC > 0
 #include <sys/verified_exec.h>
@@ -204,6 +202,7 @@
 #ifdef PTRACE
 #include <sys/ptrace.h>
 #endif /* PTRACE */
+#include <sys/cprng.h>
 
 #include <sys/syscall.h>
 #include <sys/syscallargs.h>
@@ -260,6 +259,8 @@
 
 int	start_init_exec;		/* semaphore for start_init() */
 
+cprng_strong_t	*kern_cprng;
+
 static void check_console(struct lwp *l);
 static void start_init(void *);
 static void configure(void);
@@ -375,9 +376,9 @@
 	/*
 	 * The following things must be done before autoconfiguration.
 	 */
-#if NRND > 0
-	rnd_init();		/* initialize random number generator */
-#endif
+	rnd_init();		/* initialize entropy pool */
+
+	cprng_init();		/* initialize cryptographic PRNG */
 
 	/* Initialize process and pgrp structures. */
 #ifdef KERN_SA
@@ -501,6 +502,9 @@
 	/* Initialize the disk wedge subsystem. */
 	dkwedge_init();
 
+	/* Initialize the kernel strong PRNG. */
+	kern_cprng = cprng_strong_create("kernel_cprng", IPL_VM);
+					 
 	/* Initialize interfaces. */
 	ifinit1();
 
@@ -509,7 +513,6 @@
 	/* Initialize sockets thread(s) */
 	soinit1();
 
-
 	/* Configure the system hardware.  This will enable interrupts. */
 	configure();
 
Index: kern/init_sysctl.c
===================================================================
RCS file: /cvsroot/src/sys/kern/init_sysctl.c,v
retrieving revision 1.183
diff -u -b -r1.183 init_sysctl.c
--- kern/init_sysctl.c	30 Aug 2011 12:39:59 -0000	1.183
+++ kern/init_sysctl.c	31 Oct 2011 04:29:23 -0000
@@ -38,7 +38,6 @@
 #include "opt_sa.h"
 #include "opt_posix.h"
 #include "pty.h"
-#include "rnd.h"
 
 #include <sys/types.h>
 #include <sys/param.h>
@@ -49,7 +48,7 @@
 #include <sys/kernel.h>
 #include <sys/unistd.h>
 #include <sys/disklabel.h>
-#include <sys/rnd.h>
+#include <sys/cprng.h>
 #include <sys/vnode.h>
 #include <sys/mount.h>
 #include <sys/namei.h>
@@ -1395,12 +1394,9 @@
 static int
 sysctl_kern_urnd(SYSCTLFN_ARGS)
 {
-#if NRND > 0
 	int v, rv;
 
-	KERNEL_LOCK(1, NULL);
-	rv = rnd_extract_data(&v, sizeof(v), RND_EXTRACT_ANY);
-	KERNEL_UNLOCK_ONE(NULL);
+	rv = cprng_strong(sysctl_prng, &v, sizeof(v));
 	if (rv == sizeof(v)) {
 		struct sysctlnode node = *rnode;
 		node.sysctl_data = &v;
@@ -1408,9 +1404,6 @@
 	}
 	else
 		return (EIO);	/*XXX*/
-#else
-	return (EOPNOTSUPP);
-#endif
 }
 
 /*
@@ -1420,7 +1413,6 @@
 static int
 sysctl_kern_arnd(SYSCTLFN_ARGS)
 {
-#if NRND > 0
 	int error;
 	void *v;
 	struct sysctlnode node = *rnode;
@@ -1431,15 +1423,12 @@
 		return E2BIG;
 
 	v = kmem_alloc(*oldlenp, KM_SLEEP);
-	arc4randbytes(v, *oldlenp);
+	cprng_fast(v, *oldlenp);
 	node.sysctl_data = v;
 	node.sysctl_size = *oldlenp;
 	error = sysctl_lookup(SYSCTLFN_CALL(&node));
 	kmem_free(v, *oldlenp);
 	return error;
-#else
-	return (EOPNOTSUPP);
-#endif
 }
 /*
  * sysctl helper routine to do kern.lwp.* work.
Index: kern/kern_exec.c
===================================================================
RCS file: /cvsroot/src/sys/kern/kern_exec.c,v
retrieving revision 1.329
diff -u -b -r1.329 kern_exec.c
--- kern/kern_exec.c	16 Sep 2011 21:02:28 -0000	1.329
+++ kern/kern_exec.c	31 Oct 2011 04:29:24 -0000
@@ -103,6 +103,7 @@
 #include <sys/verified_exec.h>
 #endif /* NVERIEXEC > 0 */
 #include <sys/sdt.h>
+#include <sys/cprng.h>
 
 #include <uvm/uvm_extern.h>
 
@@ -780,7 +781,7 @@
 
 #ifdef PAX_ASLR
 	if (pax_aslr_active(l))
-		len += (arc4random() % PAGE_SIZE);
+		len += (cprng_fast32() % PAGE_SIZE);
 #endif /* PAX_ASLR */
 
 #ifdef STACKALIGN	/* arm, etc. */
Index: kern/kern_pax.c
===================================================================
RCS file: /cvsroot/src/sys/kern/kern_pax.c,v
retrieving revision 1.25
diff -u -b -r1.25 kern_pax.c
--- kern/kern_pax.c	24 Apr 2011 18:46:22 -0000	1.25
+++ kern/kern_pax.c	31 Oct 2011 04:29:24 -0000
@@ -43,6 +43,7 @@
 #include <sys/vnode.h>
 #include <sys/queue.h>
 #include <sys/kauth.h>
+#include <sys/cprng.h>
 
 #ifdef PAX_ASLR
 #include <sys/mman.h>
@@ -310,7 +311,7 @@
 	if (!pax_aslr_active(l))
 		return;
 
-	vm->vm_aslr_delta_mmap = PAX_ASLR_DELTA(arc4random(),
+	vm->vm_aslr_delta_mmap = PAX_ASLR_DELTA(cprng_fast32(),
 	    PAX_ASLR_DELTA_MMAP_LSB, PAX_ASLR_DELTA_MMAP_LEN);
 }
 
@@ -344,7 +345,7 @@
 pax_aslr_stack(struct lwp *l, struct exec_package *epp, u_long *max_stack_size)
 {
 	if (pax_aslr_active(l)) {
-		u_long d =  PAX_ASLR_DELTA(arc4random(),
+		u_long d =  PAX_ASLR_DELTA(cprng_fast32(),
 		    PAX_ASLR_DELTA_STACK_LSB,
 		    PAX_ASLR_DELTA_STACK_LEN);
 #ifdef PAX_ASLR_DEBUG
Index: kern/kern_ssp.c
===================================================================
RCS file: /cvsroot/src/sys/kern/kern_ssp.c,v
retrieving revision 1.5
diff -u -b -r1.5 kern_ssp.c
--- kern/kern_ssp.c	1 Feb 2010 16:14:58 -0000	1.5
+++ kern/kern_ssp.c	31 Oct 2011 04:29:24 -0000
@@ -32,6 +32,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/intr.h>
+#include <sys/cprng.h>
 
 #if defined(__SSP__) || defined(__SSP_ALL__)
 long __stack_chk_guard[8] = {0, 0, 0, 0, 0, 0, 0, 0};
@@ -57,7 +58,7 @@
 	size_t i;
 	long guard[__arraycount(__stack_chk_guard)];
 
-	arc4randbytes(guard, sizeof(guard));
+	cprng_fast(guard, sizeof(guard));
 	s = splhigh();
 	for (i = 0; i < __arraycount(guard); i++)
 		__stack_chk_guard[i] = guard[i];
Index: kern/kern_sysctl.c
===================================================================
RCS file: /cvsroot/src/sys/kern/kern_sysctl.c,v
retrieving revision 1.232
diff -u -b -r1.232 kern_sysctl.c
--- kern/kern_sysctl.c	5 Oct 2011 13:24:09 -0000	1.232
+++ kern/kern_sysctl.c	31 Oct 2011 04:29:24 -0000
@@ -84,6 +84,7 @@
 #include <sys/syscallargs.h>
 #include <sys/kauth.h>
 #include <sys/ktrace.h>
+#include <sys/cprng.h>
 
 #define	MAXDESCLEN	1024
 MALLOC_DEFINE(M_SYSCTLNODE, "sysctlnode", "sysctl node structures");
@@ -158,6 +159,8 @@
 #endif
 char defcorename[MAXPATHLEN] = DEFCORENAME;
 
+cprng_strong_t *sysctl_prng;
+
 /*
  * ********************************************************************
  * Section 0: Some simple glue
@@ -245,12 +248,15 @@
  * trees that claim to be readonly at the root now are, and if
  * the main tree is readonly, *everything* is.
  *
+ * Also starts up the PRNG used for the "random" sysctl: it's
+ * better to start it later than sooner.
+ *
  * Call this at the end of kernel init.
  */
 void
 sysctl_finalize(void)
 {
-
+        sysctl_prng = cprng_strong_create("sysctl", IPL_NONE);
 	sysctl_root.sysctl_flags |= CTLFLAG_PERMANENT;
 }
 
